function [F0,F1]=treinaMPCLrelatorio(X,d)

% X -  o conjunto de padres de treinamento
% d -  o vetor que indica  classe corresponde cada coluna de X
% F0 - Sada contendo as caixinhas da classe 0
% F1 - Sada contendo as caixinhas da classe 1

% N  dimenso dos padres de treinamento;
% nX  numero de elementos no conjunto de treinamento;
[N,nX]=size(X);

% nF0 e nF1 representam o nmero de hiper-caixas em F0 e F1.
nF0=0; nF1=0;

% Indices dos conjuntos das classes C0 e C1;
C0=find(d==0);
C1=find(d==1);

% Inicializar o conjunto E;
E=[1:nX];
F0=[];
F1=[];
while length(E)>0
	Xb=E;
	Cb0=intersect(Xb,C0);
	Cb1=intersect(Xb,C1);

	% Calculando as menores hiper-caixas;

  	if length(Cb0)==0
		a1=min(X(:,Cb1),[],2);
		b1=max(X(:,Cb1),[],2);
		nF1=nF1+1; F1(:,nF1)=[a1;b1];
		return
	else
		a0=min(X(:,Cb0),[],2);
		b0=max(X(:,Cb0),[],2);
  	end
  	if length(Cb1)==0
		a0=min(X(:,Cb0),[],2);
		b0=max(X(:,Cb0),[],2);
		nF0=nF0+1; F0(:,nF0)=[a0;b0];
		return
	else
		a1=min(X(:,Cb1),[],2);
		b1=max(X(:,Cb1),[],2);
  	end

	% Calculando a interseco das hiper-caixas;
	a=max(a0,a1);
	b=min(b0,b1);

	if min(a>b)
		E=setdiff(E,Xb);
		% Adicionar as hiper-caixas.
		nF0=nF0+1; F0(:,nF0)=[a0;b0];

		nF1=nF1+1; F1(:,nF1)=[a1;b1];
	else
		if min((a0==a1)&(b0==b1))
			% Caso b) da dissertao;
			P=[]; % Hiperplanos P;
			k=0; % Contador do nmero de hiperplanos P;
			% Vamos definir o conjunto de hiperplanos P;

			% Aqui estamos tomando o ponto b
			for i=1:N
				npi(i)=nnz(X(i,Xb)==b(i)); % Nmero de padres de treinamento i;
			end
			
			for i=1:N
				if npi(i)<=min(npi)
					P=union(P,i);
					k=k+1;
				end
			end

			% Calcular os pontos u que esto nas intereseces de dois planos de U;
			UP=[];
			for i=1:k
				for j=i+1:k
					ind=find(X(P(i),Xb)==b(P(i)));
					ind=find(X(P(j),ind)==b(P(j)));
					for l=1:length(ind)
						if d(ind(l))==0
							nF0=nF0+1; F0(:,nF0)=X(:,ind(l));
						else
							nF1=nF1+1; F1(:,nF1)=X(:,ind(l));
						end
					end
					UP=union(UP,ind);
				end
			end
			E=setdiff(E,UP);
			
			% Aqui terminamos de classificar os pontos que esto sob as arestas do cubo

			% Classificaremos agora os padres do plano que possui o menor nmero de elementos
			ind1=[];		

			for i=1:length(P)
				ind1=union(ind1,find(X(P(i),:)==b(P(i))));

				% Removendo esses padres j classificados
				E=setdiff(E,ind1);
			end
			% Chamaremos recursivamente a funo treina MPCL para classificar os elementos separadamente
			F01=[];
			F11=[];
			[F01,F11]=treinaMPCLrelatorio(X(:,ind1),d(ind1));
			for i=1:min(size(F01))
				nF0=nF0+1; 
				F0(:,nF0)=[F01(:,i)];
			end
			
			for i=1:min(size(F11))
				nF1=nF1+1;
				F1(:,nF1)=[F11(:,i)];
			end

		else
			% Caso a) da dissertao;
			for i=1:N
				% Calculo para a classe 0;
				% Equao (12) da dissertao
				ind=find(X(i,Cb0)<a(i));
				if length(ind)>0
					% Adicionar a hiper-caixa;
					nF0=nF0+1; 
					F0(:,nF0)=[min(X(:,Cb0(ind)),[],2);max(X(:,Cb0(ind)),[],2)];

				end
				% Equao (13) da dissertao
				ind=find(X(i,Cb0)>b(i));
				if length(ind)>0
					% Adicionar a hiper-caixa;
					nF0=nF0+1; 
					F0(:,nF0)=[min(X(:,Cb0(ind)),[],2);max(X(:,Cb0(ind)),[],2)];
				end
				% Calculo para a classe 1;
				% Equao (12) da dissertao
				ind=find(X(i,Cb1)<a(i));
				if length(ind)>0
					% Adicionar a hiper-caixa;
					nF1=nF1+1; 
					F1(:,nF1)=[min(X(:,Cb1(ind)),[],2);max(X(:,Cb1(ind)),[],2)];
				end
				% Equao (13) da dissertao
				ind=find(X(i,Cb1)>b(i));
				if length(ind)>0
					% Adicionar a hiper-caixa;
					nF1=nF1+1; 
					F1(:,nF1)=[min(X(:,Cb1(ind)),[],2);max(X(:,Cb1(ind)),[],2)];
				end
			end
			% Calculando a interseo de Xb com I;
			ind=[];
			for i=1:N
				ind=union(ind,find(X(i,Xb)>b(i)));
				ind=union(ind,find(X(i,Xb)<a(i)));
			end
			if length(ind)>0
				E=setdiff(E,Xb(ind));
			else
				E=setdiff(E,Xb);
			end	
		end
	end
end
%  disp('Terminou 100% Certo');
end
